﻿using HEAL.Attic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Problems.DataAnalysis {
  [StorableType("8E3FEB9B-0B1A-4F06-8CFC-CB8D468EF7EC")]
  [Item("Region", "A region for an interval constraint.")]
  public class Region : Item {

    [Storable] private string variableName;
    public string VariableName {
      get => variableName;
      private set {
        if(variableName != value) {
          variableName = value;
          OnChanged();
        }
      }
    }

    [Storable] private Interval interval;
    public Interval Interval {
      get => Interval;
      private set {
        if (!interval.Equals(value)) {
          interval = value;
          OnChanged();
        }
      }
    }

    public Region(string variableName, Interval interval) {
      VariableName = variableName;
      Interval = interval;
    }

    private Region(Region original, Cloner cloner)
      : base(original, cloner) {
      VariableName = original.VariableName;
      Interval = original.Interval;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Region(this, cloner);
    }

    public event EventHandler Changed;
    private void OnChanged() => Changed?.Invoke(this, EventArgs.Empty);
  }
}
